package com.mylar.sample.file;

public class FileAttribute
{
	private final String attributeName;
	private final String prettyName;
	private final String mylarTaskKey;
	private final boolean isHidden;
	private final boolean isReadOnly;
	
	FileAttribute(String attributeName, String prettyName, String taskKey, boolean hidden, boolean readonly) 
	{		
		this.attributeName = attributeName;
		this.mylarTaskKey = taskKey;
		this.prettyName = prettyName;
		this.isHidden = hidden;
		this.isReadOnly = readonly;
	}

	FileAttribute(String attributeName, String prettyName, String taskKey, boolean hidden)
	{		
		this(attributeName, prettyName, taskKey, hidden, false);
	}
	
	FileAttribute(String attributeName, String prettyName, String taskKey)
	{		
		this(attributeName, prettyName, taskKey, false, false);
	}

	public String getTaskKey()
	{
		return mylarTaskKey;
	}

	public String getAttributeName()
	{
		return attributeName;
	}

	public boolean isHidden()
	{
		return isHidden;
	}	
	
	public boolean isReadOnly()
	{
		return isReadOnly;
	}
	
	public String toString()
	{
		return prettyName;
	}

}
