package com.mylar.sample.file;

import org.eclipse.mylar.tasks.core.AbstractQueryHit;
import org.eclipse.mylar.tasks.core.AbstractRepositoryTask;
import org.eclipse.mylar.tasks.core.TaskList;

import com.mylar.sample.file.FileTask;

/**
 * Class used to represent a hit from the exceution of a query.
 */
public class FileQueryHit extends AbstractQueryHit
{
	private String status = null;

	/**
	 * Class constructor.  Performs basic initialization for the class instance.
	 * 
	 * @param taskList
	 * @param description		Descrition of the found task.
	 * @param priority			Priority of the task
	 * @param repositoryUrl		URL of repository the task belongs to.
	 * @param id				Id of the task
	 * @param task				The task 
	 * @param status			The status of the task.
	 */
	public FileQueryHit(TaskList taskList, String description, String priority, String repositoryUrl, String id,
			String status) {
		super(taskList, repositoryUrl, description, id);
		super.priority = priority;
		this.status = status;
	}

	protected AbstractRepositoryTask createTask()
	{
		return FileRepositoryConnector.createTask(getHandleIdentifier(), getSummary());
	}


	/**
	 * Returns an indication if the task is complete.
	 */
	public boolean isCompleted()
	{
		if (status != null && (status.startsWith("RESO") || status.startsWith("CLO") || status.startsWith("VERI") || status
						.startsWith("FIXED")))
		{
			return true;
		}
		return false;
	}

}
