package com.mylar.sample.file;

import org.eclipse.mylar.tasks.core.AbstractRepositoryQuery;
import org.eclipse.mylar.tasks.core.TaskList;

import com.mylar.sample.Activator;

/**
 * Class used to hold a query created for a repository
*/
public class FileRepositoryQuery extends AbstractRepositoryQuery {

	private boolean customQuery = false;

	/**
	 * Class constructor.  Performs basic initialization for the class instance.
	 * 
	 * @param repositoryUrl	Url of the repository to be queried.
	 * @param queryUrl		The query url
	 * @param description	Description of the query.  Used in 'tasklist' display.
	 * @param maxHits		Max number of this the query should return.		
	 * @param taskList
	 */
	public FileRepositoryQuery(String repositoryUrl, String queryUrl, String description, String maxHits, TaskList taskList) {
		super(description, taskList);
		this.url = queryUrl;
		this.repositoryUrl = repositoryUrl;
		try 
		{
			this.maxHits = Integer.parseInt(maxHits);
		}
		catch (Exception e)
		{
			this.maxHits = -1;
		}
	}

	public String getRepositoryKind()
	{
		return Activator.FILE_REPOSITORY_KIND;
	}

	public boolean isCustomQuery()
	{
		return customQuery;
	}

	public void setCustomQuery(boolean customQuery)
	{
		this.customQuery = customQuery;
	}
}
