package com.mylar.sample.file;

import org.eclipse.mylar.tasks.core.AbstractRepositoryTask;

import com.mylar.sample.Activator;

/**
 * This class represents Mylar task.
 */
public class FileTask extends AbstractRepositoryTask
{
	/**
	 * Class constructor.  Performs basic iniitalization for class instance
	 * 
	 * @param handle
	 * @param label			Label for the task
	 * @param newTask		Indication if the task is new.
	 */
	public FileTask(String handle, String label, boolean newTask)
	{
		super(handle, label, newTask);
		isDirty = false;
	}
	
	/**
	 * Class constructor.  Performs basic initialization of the class instance
	 * using a 'query hit'
	 * 
	 * @param hit			The query hit.
	 * @param newTask		Indication if the task is new.
	 */
	public FileTask(FileQueryHit hit, boolean newTask)
	{
		this(hit.getHandleIdentifier(), hit.getSummary(), newTask);
		setPriority(hit.getPriority());
	}
	
	/**
	 * Returns the repository kind.
	 */
	public String getRepositoryKind()
	{
		return Activator.FILE_REPOSITORY_KIND;
	}


}
