package com.mylar.sample.file.ui;

import org.eclipse.jface.wizard.WizardPage;
import org.eclipse.swt.SWT;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Text;

import org.eclipse.mylar.tasks.core.RepositoryTaskData;
import org.eclipse.mylar.tasks.core.TaskRepository;
import org.eclipse.mylar.tasks.ui.TasksUiPlugin;

import com.mylar.sample.Activator;
import com.mylar.sample.file.FileAttributeFactory;

public class FileRepositoryNewTaskPage extends WizardPage
{

	private TaskRepository taskRepository;

	private RepositoryTaskData taskData;

	public FileRepositoryNewTaskPage(TaskRepository taskRepository)
	{
		super("New File Repository Task");

		setTitle("Create via Rich Editor");
		setDescription("This will open an editor that can be used to create a new task.");

		this.taskRepository = taskRepository;
	}

	public void setVisible(boolean visible) {
		super.setVisible(visible);
		updateAttributesFromRepository();
	}
	
	public void createControl(Composite parent) {
		Text text = new Text(parent, SWT.WRAP);
		text.setEditable(false);
		setControl(text);
	}
	
	public boolean isPageComplete() {
		return taskData != null;
	}
	
	private void updateAttributesFromRepository()
	{
		FileAttributeFactory attributeFactory = new FileAttributeFactory(taskRepository.getUrl());
		taskData = new RepositoryTaskData(attributeFactory, Activator.FILE_REPOSITORY_KIND, taskRepository.toString(), "" +TasksUiPlugin.getDefault().getNextNewRepositoryTaskId());
	}

	public RepositoryTaskData getRepositoryTaskData() {
		return taskData;
	}
	
}
