package com.mylar.sample.file.ui;

import org.eclipse.jface.viewers.IStructuredSelection;
import org.eclipse.jface.wizard.Wizard;
import org.eclipse.mylar.internal.tasks.ui.TaskListImages;
import org.eclipse.mylar.internal.tasks.ui.TaskListPreferenceConstants;
import org.eclipse.mylar.tasks.core.TaskRepository;
import org.eclipse.mylar.tasks.ui.TasksUiUtil;
import org.eclipse.mylar.tasks.ui.editors.NewTaskEditorInput;
import org.eclipse.ui.INewWizard;
import org.eclipse.ui.IWorkbench;
import org.eclipse.ui.IWorkbenchPage;
import org.eclipse.ui.PlatformUI;

import com.mylar.sample.file.ui.FileRepositoryNewTaskPage;


/**
 * Wizard for creating new Trac tickets through a rich editor..
 * 
 * @author Steffen Pingel
 */
public class FileRepositoryNewTaskWizard extends Wizard implements INewWizard {

	private TaskRepository taskRepository;

	private FileRepositoryNewTaskPage newTaskPage;

	public FileRepositoryNewTaskWizard(TaskRepository taskRepository) {
		this.taskRepository = taskRepository;

		newTaskPage = new FileRepositoryNewTaskPage(taskRepository);
		
		setWindowTitle("New File Repository Task");
		setDefaultPageImageDescriptor(TaskListImages.BANNER_REPOSITORY);
		
		setNeedsProgressMonitor(true);
	}

	public void init(IWorkbench workbench, IStructuredSelection selection) {
	}

	@Override
	public void addPages() {
		addPage(newTaskPage);
	}

	@Override
	public boolean canFinish() {
		return true;
	}

	@Override
	public boolean performFinish() {
		NewTaskEditorInput editorInput = new NewTaskEditorInput(taskRepository, newTaskPage.getRepositoryTaskData());
		IWorkbenchPage page = PlatformUI.getWorkbench().getActiveWorkbenchWindow().getActivePage();
		TasksUiUtil.openEditor(editorInput, TaskListPreferenceConstants.TASK_EDITOR_ID, page);
		return true;
	}

}
