package com.mylar.sample.file.ui.editor;
import java.util.Arrays;

import org.eclipse.jface.layout.GridDataFactory;
import org.eclipse.mylar.tasks.core.ITask;
import org.eclipse.mylar.tasks.core.RepositoryTaskAttribute;
import org.eclipse.mylar.tasks.core.RepositoryTaskData;
import org.eclipse.mylar.tasks.ui.TasksUiPlugin;
import org.eclipse.mylar.tasks.ui.editors.AbstractRepositoryTaskEditor;
import org.eclipse.mylar.tasks.ui.editors.AbstractTaskEditorInput;
import org.eclipse.mylar.tasks.ui.editors.RepositoryTaskEditorInput;
import org.eclipse.mylar.tasks.ui.editors.RepositoryTaskOutlineNode;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.List;
import org.eclipse.ui.IEditorInput;
import org.eclipse.ui.IEditorSite;
import org.eclipse.ui.forms.editor.FormEditor;
import org.eclipse.ui.forms.widgets.FormToolkit;


import com.mylar.sample.file.FileAttributeFactory;
import com.mylar.sample.file.FileRepositoryConnector;

/**
 * @author Mik Kersten
 * @author Rob Elves
 */
public class FileTaskEditor extends AbstractRepositoryTaskEditor {

	//private static final String SUBMIT_JOB_LABEL = "Submitting to JIRA repository";

	private RepositoryTaskData taskData;

	public FileTaskEditor(FormEditor editor)
	{
		super(editor);
	}

	public void init(IEditorSite site, IEditorInput input)
	{
		if (!(input instanceof RepositoryTaskEditorInput))
			return;

		editorInput = (AbstractTaskEditorInput) input;
		taskData = editorInput.getTaskData();
		repository = editorInput.getRepository();
		connector = (FileRepositoryConnector) TasksUiPlugin.getRepositoryManager().getRepositoryConnector(
				repository.getKind());

		taskOutlineModel = RepositoryTaskOutlineNode.parseBugReport(editorInput.getTaskData());

		setSite(site);
		setInput(input);
		isDirty = false;
		updateEditorTitle();
	}

	protected void addAttachContextButton(Composite buttonComposite, ITask task) {
		// disabled
	}

	protected void createPeopleLayout(Composite composite) {
		// disabled
	}
	protected void createCustomAttributeLayout(Composite composite)
	{
/*
		FormToolkit toolkit = getManagedForm().getToolkit();
		Label label = toolkit.createLabel(composite, "Components:");
		GridDataFactory.fillDefaults().align(SWT.RIGHT, SWT.CENTER).applyTo(label);

		final List componentsList = new List(composite, SWT.MULTI | SWT.V_SCROLL);
		componentsList.setData(FormToolkit.KEY_DRAW_BORDER, FormToolkit.TEXT_BORDER);
		componentsList.setFont(TEXT_FONT);
		GridData compTextData = new GridData(GridData.HORIZONTAL_ALIGN_FILL);
		compTextData.horizontalSpan = 1;
		compTextData.widthHint = 125;
		compTextData.heightHint = 40;
		componentsList.setLayoutData(compTextData);
*/
/*
		RepositoryTaskAttribute attribute = taskData.getAttribute(JiraAttributeFactory.ATTRIBUTE_COMPONENTS);
		if (attribute != null && !attribute.getOptions().isEmpty()) {
			componentsList.setItems(attribute.getOptions().toArray(new String[1]));
			for (String compStr : taskData.getAttributeValues(JiraAttributeFactory.ATTRIBUTE_COMPONENTS)) {
				componentsList.select(componentsList.indexOf(compStr));
			}
			componentsList.addSelectionListener(new SelectionAdapter() {

				@Override
				public void widgetSelected(SelectionEvent e) {
					RepositoryTaskAttribute attribute = taskData
							.getAttribute(JiraAttributeFactory.ATTRIBUTE_COMPONENTS);
					attribute.clearValues();
					attribute.setValues(Arrays.asList(componentsList.getSelection()));
					markDirty(true);
					
				}
			});
		}
*/
/*
		label = toolkit.createLabel(composite, "Fix Versions:");
		GridDataFactory.fillDefaults().align(SWT.RIGHT, SWT.CENTER).applyTo(label);
		final List versionsList = new List(composite, SWT.MULTI | SWT.V_SCROLL);
		versionsList.setData(FormToolkit.KEY_DRAW_BORDER, FormToolkit.TEXT_BORDER);
		versionsList.setFont(TEXT_FONT);
		GridData versionsTextData = new GridData(GridData.HORIZONTAL_ALIGN_FILL);
		versionsTextData.horizontalSpan = 1;
		versionsTextData.widthHint = 125;
		versionsTextData.heightHint = 40;
		versionsList.setLayoutData(versionsTextData);
*/
/*
		attribute = taskData.getAttribute(JiraAttributeFactory.ATTRIBUTE_FIXVERSIONS);
		if (attribute != null && !attribute.getOptions().isEmpty()) {
			versionsList.setItems(attribute.getOptions().toArray(new String[1]));
			for (String versionStr : taskData.getAttributeValues(JiraAttributeFactory.ATTRIBUTE_FIXVERSIONS)) {
				versionsList.select(versionsList.indexOf(versionStr));
			}
			versionsList.addSelectionListener(new SelectionAdapter() {

				@Override
				public void widgetSelected(SelectionEvent e) {
					RepositoryTaskAttribute attribute = taskData
							.getAttribute(JiraAttributeFactory.ATTRIBUTE_FIXVERSIONS);
					attribute.clearValues();
					attribute.setValues(Arrays.asList(versionsList.getSelection()));
					markDirty(true);
				}
			});
		}
*/
/*
		label = toolkit.createLabel(composite, "Affects Versions:");
		GridDataFactory.fillDefaults().align(SWT.RIGHT, SWT.CENTER).applyTo(label);
		final List affectsVersionsList = new List(composite, SWT.MULTI | SWT.V_SCROLL);
		affectsVersionsList.setData(FormToolkit.KEY_DRAW_BORDER, FormToolkit.TEXT_BORDER);
		affectsVersionsList.setFont(TEXT_FONT);
		GridData affectsVersionsTextData = new GridData(GridData.HORIZONTAL_ALIGN_FILL);
		affectsVersionsTextData.horizontalSpan = 1;
		affectsVersionsTextData.widthHint = 125;
		affectsVersionsTextData.heightHint = 40;
		affectsVersionsTextData.verticalIndent = 3;
		affectsVersionsList.setLayoutData(affectsVersionsTextData);
*/
/*
		attribute = taskData.getAttribute(JiraAttributeFactory.ATTRIBUTE_AFFECTSVERSIONS);
		if (attribute != null && !attribute.getOptions().isEmpty()) {
			affectsVersionsList.setItems(attribute.getOptions().toArray(new String[1]));
			for (String versionStr : taskData.getAttributeValues(JiraAttributeFactory.ATTRIBUTE_AFFECTSVERSIONS)) {
				affectsVersionsList.select(affectsVersionsList.indexOf(versionStr));
			}
			affectsVersionsList.addSelectionListener(new SelectionAdapter() {

				@Override
				public void widgetSelected(SelectionEvent e) {
					RepositoryTaskAttribute attribute = taskData
							.getAttribute(JiraAttributeFactory.ATTRIBUTE_AFFECTSVERSIONS);
					attribute.clearValues();
					attribute.setValues(Arrays.asList(affectsVersionsList.getSelection()));
					markDirty(true);
				}
			});
		}
*/
	}

	@Override
	protected void validateInput() {
		// TODO Auto-generated method stub
	}
	
	@Override
	protected String getPluginId() {
		return "File";
	}

}
